%exam_8_36
clear;clc
M=35;wc=pi/5;                                           % 理想低通滤波器参数
n=0:M-1;r=(M-1)/2;
nr=n-r+eps*((n-r)==0);
hdn=sin(wc*nr)/pi./nr;                                 % 计算理想低通单位脉冲响应hd(n)
if rem(M,2)~=0,hdn(r+1)=wc/pi;end;                   % M为奇数时，处理n=r点的0/0型
wn1=boxcar(M);                                           % 矩形窗
hn1=hdn.*wn1';                                           % 加窗
subplot(2,1,1);stem(n,hn1,'.');line([0,20],[0,0]);
xlabel('n','Fontsize',20),ylabel('h(n)','Fontsize',20),title ('通过矩形窗得到的数字滤波器h(n)','Fontsize',20);
set(gca,'Fontsize',20);
hw1=fft(hn1,512);w1=2*[0:511]/512;                   % 求频谱
subplot(2,1,2),plot(w1,20*log10(abs(hw1)))
xlabel('w/pi','Fontsize',20);ylabel('Amplitude','Fontsize',20);title ('幅度特性','Fontsize',20);
set(gca,'Fontsize',20);


